package de.thpeetz.kontor.tysc.views;

import java.util.List;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.grid.Grid;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.tysc.data.FieldPosition;
import de.thpeetz.kontor.tysc.data.Rooster;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class PositionForm extends FormLayout {

    TextField name = new TextField("Name");
    Grid<Rooster> roosters = new Grid<>(Rooster.class);

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<FieldPosition> binder = new BeanValidationBinder<>(FieldPosition.class);

    public PositionForm() {
        addClassName("position-form");
        binder.bindInstanceFields(this);

        roosters.setColumns("player.fullName", "team.name", "year");
        roosters.getColumns().forEach(col -> col.setAutoWidth(true));
        add(name, roosters, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setPosition(FieldPosition position) {
        binder.setBean(position);
    }

    public void setRoosters(List<Rooster> roosters) {
        log.info("Setting roosters: {}", roosters);
        this.roosters.setItems(roosters);
    }

    public abstract static class PositionFormEvent extends ComponentEvent<PositionForm> {
        private FieldPosition position;

        protected PositionFormEvent(PositionForm source, FieldPosition position) {
            super(source, false);
            this.position = position;
        }

        public FieldPosition getPosition() {
            return position;
        }
    }

    public static class SaveEvent extends PositionFormEvent {
        SaveEvent(PositionForm source, FieldPosition position) {
            super(source, position);
        }
    }

    public static class DeleteEvent extends PositionFormEvent {
        DeleteEvent(PositionForm source, FieldPosition position) {
            super(source, position);
        }
    }

    public static class CloseEvent extends PositionFormEvent {
        CloseEvent(PositionForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
